"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  LoggerControl: () => LoggerControl
});
module.exports = __toCommonJS(src_exports);
var import_discord = require("discord.js");
var import_pure_cat = require("pure-cat");
class LoggerControl extends import_pure_cat.Module {
  commands = [
    new import_pure_cat.Command(
      "log-dump",
      'Dumps the log to a file and send it to channel "pure-logger".'
    ).handle(async (interaction, bot) => {
      const guild = interaction.guild;
      if (!guild) {
        return;
      }
      if (bot.logger.dumpable(guild)) {
        await interaction.reply(`Preparing to dump log ...`);
        try {
          await bot.logger.dump(guild);
          bot.logger.log(guild, {
            actor: interaction.user.username,
            message: `log dumped.`
          });
          await interaction.editReply(`Log dumped.`);
        } catch (err) {
          await interaction.editReply(`Failed to dump log: ${err}`);
        }
      } else {
        const row = new import_discord.ActionRowBuilder().addComponents(
          new import_discord.ButtonBuilder().setCustomId("create-pure-logger").setLabel('Create Channel "Pure Logger"').setStyle(import_discord.ButtonStyle.Primary)
        );
        await interaction.reply({
          ephemeral: true,
          content: `Channel "pure-logger" doesn't exist on this server.`,
          components: [row]
        });
      }
    })
  ];
  async interactionCreate(bot, interaction) {
    if (!interaction.isButton()) {
      return;
    }
    const guild = interaction.guild;
    if (!guild) {
      return;
    }
    if (interaction.customId === "create-pure-logger") {
      if (bot.logger.dumpable(guild) === true) {
        await interaction.reply({
          ephemeral: true,
          content: `Channel "pure-logger" already exists on this server.`
        });
        return;
      }
      await interaction.reply(`Creating channel "pure-logger" ...`);
      try {
        await guild.channels.create({ name: "pure-logger" });
        await interaction.editReply(`Channel "pure-logger" created.`);
      } catch (err) {
        await interaction.editReply(
          `Failed to create channel "pure-logger": ${err.message}`
        );
      }
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  LoggerControl
});
